from dataclasses import dataclass

from ..current.entities import CurrentData, ThreePhaseCurrentDataContainer
from ..entities import DataContainer
from ..frequency.entities import FrequencyData, ThreePhaseFrequencyDataContainer
from ..power_factor.entities import PowerFactorData, ThreePhasePowerFactorDataContainer
from ..voltage.entities import VoltageData, ThreePhaseVoltageDataContainer
from ..volt_amps.entities import VoltAmpsData, ThreePhaseVoltAmpsDataContainer, VoltAmpsReactiveData, ThreePhaseVoltAmpsReactiveDataContainer
from ..watts.entities import WattsData, ThreePhaseWattsDataContainer
from ..enums import DataValueType


@dataclass
class SinglePhasePowerMeterDataContainer(DataContainer):
    current: CurrentData = ...
    frequency: FrequencyData = ...
    power_factor: PowerFactorData = ...
    voltage: VoltageData = ...
    voltamps: VoltAmpsData = ...
    voltamps_reactive: VoltAmpsReactiveData = ...
    watts: WattsData = ...


@dataclass
class ThreePhasePowerMeterDataContainer(DataContainer):
    current: ThreePhaseCurrentDataContainer = ...
    frequency: ThreePhaseFrequencyDataContainer = ...
    power_factor: ThreePhasePowerFactorDataContainer = ...
    voltage: ThreePhaseVoltageDataContainer = ...
    voltamps: ThreePhaseVoltAmpsDataContainer = ...
    voltamps_reactive: ThreePhaseVoltAmpsReactiveDataContainer = ...
    watts: ThreePhaseWattsDataContainer = ...
